Index: /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/helper/ModelComposer.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/helper/ModelComposer.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/helper/ModelComposer.java	(revision 1632)
@@ -296,6 +296,6 @@
 		vbc.updateAllBindings(valueBindingsPackage, null, treeParentToStartTheCheckOn, virtualInstantiationTreeRoot, false, true, false, true);
 		
-		if ( vbc.getAllRequiredClientsFound().size() > 0 
-				&& !vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllRequiredClientsFound())) {
+		if ( vbc.getAllMandatoryClientsFound().size() > 0 
+				&& !vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllMandatoryClientsFound())) {
 			allRequiredClientsAreSatisfied = false;
 		}
@@ -303,5 +303,5 @@
 		// Collect all mandatory clients that are not satisfied.
 		HashSet<TreeObject> unsatisfiedRequiredClients = new HashSet<TreeObject>();
-		unsatisfiedRequiredClients.addAll(vbc.getAllRequiredClientsFound());
+		unsatisfiedRequiredClients.addAll(vbc.getAllMandatoryClientsFound());
 		unsatisfiedRequiredClients.removeAll(vbc.getAllClientsWithPossibleBindingCodeDerivation());
 
Index: /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/model/TreeBuilder.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/model/TreeBuilder.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.traceability/src/org/openmodelica/modelicaml/traceability/views/model/TreeBuilder.java	(revision 1632)
@@ -326,8 +326,12 @@
 				for (Element requirement : requirements) {
 					addToMapList(reqToScenarios, requirement, scenario);
-					if (tsmc.getUnsatisfiedRequiredClients(requirement) != null) {
+					
+					
+					//if NOT all mandatory are satisfied 
+					if (tsmc.getModelClients(requirement) != null && tsmc.getUnsatisfiedMandatoryClients(requirement) != null) {
 						requirementsWithUnsatisfiedClients.add(requirement);
 					}
-					else {
+					// if requirement has clients at all
+					else if (tsmc.getModelClients(requirement) != null) {
 						requirementsValid.add(requirement);
 					}
@@ -566,5 +570,5 @@
 					
 					// get unsatisfied clients
-					HashSet<org.openmodelica.modelicaml.common.instantiation.TreeObject> unsatisfiedClients = combination.getUnsatisfiedRequiredClients(req);
+					HashSet<org.openmodelica.modelicaml.common.instantiation.TreeObject> unsatisfiedClients = combination.getUnsatisfiedMandatoryClients(req);
 					if (unsatisfiedClients != null) {
 						for (org.openmodelica.modelicaml.common.instantiation.TreeObject treeObject : unsatisfiedClients) {
Index: /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/display/ViewLabelProvider.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/display/ViewLabelProvider.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/display/ViewLabelProvider.java	(revision 1632)
@@ -38,4 +38,5 @@
 import java.util.ArrayList;
 import java.util.HashSet;
+import java.util.List;
 
 import org.eclipse.core.resources.IMarker;
@@ -46,7 +47,4 @@
 import org.eclipse.core.resources.ResourcesPlugin;
 import org.eclipse.core.runtime.CoreException;
-import org.eclipse.emf.common.util.EList;
-import org.eclipse.emf.ecore.resource.Resource;
-import org.eclipse.emf.ecore.xmi.XMLResource;
 import org.eclipse.jface.resource.ImageDescriptor;
 import org.eclipse.jface.viewers.DecorationOverlayIcon;
@@ -62,6 +60,4 @@
 import org.eclipse.swt.graphics.RGB;
 import org.eclipse.swt.graphics.TextStyle;
-import org.eclipse.ui.ISharedImages;
-import org.eclipse.ui.PlatformUI;
 import org.eclipse.uml2.uml.Classifier;
 import org.eclipse.uml2.uml.Element;
@@ -82,5 +78,4 @@
 import org.openmodelica.modelicaml.common.utls.SWTResourceManager;
 import org.openmodelica.modelicaml.view.componentstree.Activator;
-import org.openmodelica.modelicaml.view.valuebindings.model.TreeUtls;
 
 
@@ -104,5 +99,5 @@
 	private static final String requirementInstanceStereotypeQName = Constants.stereotypeQName_RequirementInstance;
 	
-	private final ImageDescriptor warningImageDescriptor = ResourceManager.getPluginImageDescriptor("org.openmodelica.modelicaml.common", "icons/overlay/warning_ovr.gif");
+//	private final ImageDescriptor warningImageDescriptor = ResourceManager.getPluginImageDescriptor("org.openmodelica.modelicaml.common", "icons/overlay/warning_ovr.gif");
 //	private final ImageDescriptor errorImageDescriptor = ResourceManager.getPluginImageDescriptor("org.openmodelica.modelicaml.common", "icons/overlay/error_ovr.gif");
 	private final ImageDescriptor errorImageDescriptor = ResourceManager.getPluginImageDescriptor("org.openmodelica.modelicaml.common", "icons/overlay/error_ovr.gif");
@@ -398,8 +393,11 @@
 	 * @return the boolean
 	 */
+	@SuppressWarnings({ "rawtypes", "unchecked" })
 	private Boolean hasArraySize(TypedElement element, Stereotype stereotype){
-		EList<String> modList = (EList<String>) element.getValue(stereotype, "arraySize");
-		if (modList != null && modList.size() > 0) {
-			for (String string : modList) {
+		Object modList = element.getValue(stereotype, Constants.propertyName_arraySize);
+//		EList<String> modList = (EList<String>) element.getValue(stereotype, Constants.propertyName_arraySize);
+		if (modList != null && modList instanceof List && ((List)modList).size() > 0) {
+			List<String> list = (List)modList;
+			for (String string : list) {
 				if (!string.trim().equals("")) {
 					return true;
Index: /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/sections/PropertySectionDetails.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/sections/PropertySectionDetails.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/sections/PropertySectionDetails.java	(revision 1632)
@@ -42,5 +42,4 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.jface.viewers.StructuredSelection;
 import org.eclipse.papyrus.views.modelexplorer.ModelExplorerPageBookView;
 import org.eclipse.papyrus.views.modelexplorer.ModelExplorerView;
@@ -72,5 +71,4 @@
 import org.openmodelica.modelicaml.common.instantiation.ModificationManager;
 import org.openmodelica.modelicaml.common.instantiation.TreeObject;
-import org.openmodelica.modelicaml.common.services.UmlServices;
 import org.openmodelica.modelicaml.common.utls.SWTResourceManager;
 
@@ -270,38 +268,15 @@
 			return " ## Could not identify the modification source ...## ";
 		}
-		
-
-//		NamedElement modSourceElement = item.getFinalModificationSource();
-//		if (modSourceElement != null ) {
-//	//		modSource = modSourceElement.eClass().getName() + " '" + modSourceElement.getQualifiedName() + "' ";
-//			if ( item.isInherited() ) { // the modification is stored in  
-//				return "'" + item.getSelectedClass().getQualifiedName() + "' ";	
-//			}
-//			else { // then it is a component modification
-//				return "'" + modSourceElement.getName() + "' ";
-//			}
-//		}
+
 		return "";
 	}
 	
 	private String getModificationTitle(){
-//		String modSource = "";
-//	//	if (ModificationManager.isInModModListOfComponent(treeObject.getFirstLevelComponent(), treeObject.getDotPathWithoutFirstLevelComponent())) {
-//	//		modSource = " in '" + treeObject.getFirstLevelComponent().getName() + "' ";
-//	//	}
-//		NamedElement modSourceElement = item.getFinalModificationSource();
-//		if (modSourceElement != null ) {
-//	//		modSource = modSourceElement.eClass().getName() + " '" + modSourceElement.getQualifiedName() + "' ";
-//			modSource = "'" + modSourceElement.getQualifiedName() + "' ";
-//		}
 		
 		String modDescription = "";
 		if (item.getFinalModificationDescription() != null) {
 			modDescription = item.getFinalModificationDescription();
-//			return "Overriden " + modDescription  + " in " + modSource + ": ";
 			return "Overriden " + modDescription  + " in";
 		}
-		
-//		label_modification.setToolTipText(modSource);
 
 		return "";
@@ -329,7 +304,7 @@
 	        String declarationString = "";
 			if (item.getProperty() != null) {
-				Stereotype stereotype = item.getProperty().getAppliedStereotype("ModelicaML::ModelicaCompositeConstructs::Variable");
+				Stereotype stereotype = item.getProperty().getAppliedStereotype(Constants.stereotypeQName_Variable);
 				if (stereotype != null) {
-					Object declarationEquationOrAssignment = UmlServices.getStereotypeValue((Element)item.getProperty(), stereotype.getName(), "declarationEquationOrAssignment");
+					Object declarationEquationOrAssignment = item.getProperty().getValue(stereotype, Constants.propertyName_declarationEquationOrAssignment);
 					if (declarationEquationOrAssignment instanceof String) {
 						declarationString = " " + declarationEquationOrAssignment.toString().trim();
Index: /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/views/ComponentsTree.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/views/ComponentsTree.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.view.componentstree/src/org/openmodelica/modelicaml/view/componentstree/views/ComponentsTree.java	(revision 1632)
@@ -625,74 +625,5 @@
 	 */
 	private void makeActions() {
-		
-//		actionAddValueProvider = new Action("actionAddValueProvider") {
-//			public void run() {
-//				
-//				ISelection selection = viewer.getSelection();
-//				Object obj = ((IStructuredSelection) selection).getFirstElement();
-//				if (obj instanceof TreeObject) {
-//					TreeObject item = (TreeObject)obj;
-//					if (item.isValueClient()) {
-//						List<String> listOfAllowedMetaClassesNames = new ArrayList<String>();
-//						listOfAllowedMetaClassesNames.add("Property");
-//						String title = "Value Provider Selection";
-//						String message = "Click on a model element to be associated as Value Provider."; 
-//
-//						NOT_USED_SelectValueClientOrProviderDialog dialog = new NOT_USED_SelectValueClientOrProviderDialog(
-//								new Shell(), 
-//								SWTResourceManager.getImage(NOT_USED_SelectValueClientOrProviderDialog.class,"/icons/selectOnly.png"), 
-//								title, 
-//								message, 
-//								listOfAllowedMetaClassesNames,
-//								item,
-//								viewer,
-//								NOT_USED_SelectValueClientOrProviderDialog.MODE_ADD_PROVIDER,
-//								actionEditModification,
-//								actionLinkWithEditor);
-//						dialog.open();
-//					}
-//				}
-//			}
-//		};
-//		actionAddValueProvider.setText("Add a Value Provider");
-//		actionAddValueProvider.setToolTipText("Add a Value Provider");
-//		actionAddValueProvider.setImageDescriptor(ImageDescriptor.createFromFile(NOT_USED_SelectValueClientOrProviderDialog.class, "/icons/addValueProviders.png"));
-
-		
-		
-//		actionAddValueClient = new Action("actionAddValueClient") {
-//			public void run() {
-//				
-//				ISelection selection = viewer.getSelection();
-//				Object obj = ((IStructuredSelection) selection).getFirstElement();
-//				if (obj instanceof TreeObject) {
-//					TreeObject item = (TreeObject)obj;
-//					if (item.isValueProvider()) {
-//						List<String> listOfAllowedMetaClassesNames = new ArrayList<String>();
-//						listOfAllowedMetaClassesNames.add("Property");
-//						String title = "Value Client Selection";
-//						String message = "Click on a model element to be associated as Value Client."; 
-//
-//						NOT_USED_SelectValueClientOrProviderDialog dialog = new NOT_USED_SelectValueClientOrProviderDialog(
-//								new Shell(), 
-//								SWTResourceManager.getImage(NOT_USED_SelectValueClientOrProviderDialog.class,"/icons/selectOnly.png"), 
-//								title, 
-//								message, 
-//								listOfAllowedMetaClassesNames,
-//								item,
-//								viewer,
-//								NOT_USED_SelectValueClientOrProviderDialog.MODE_ADD_CLIENT,
-//								actionEditModification,
-//								actionLinkWithEditor);
-//						dialog.open();
-//					}
-//				}
-//			}
-//		};
-//		actionAddValueClient.setText("Add a Value Client");
-//		actionAddValueClient.setToolTipText("Add a Value actionAddValueClient");
-//		actionAddValueClient.setImageDescriptor(ImageDescriptor.createFromFile(NOT_USED_SelectValueClientOrProviderDialog.class, "/icons/addValueClient.png"));
-
-		
+	
 		actionAllDeleteModifications = new Action("actionAllDeleteModifications") {
 			public void run() {
@@ -872,10 +803,11 @@
 						
 						// update bindings
-//						ValueBindingCreator vc = new ValueBindingCreator();
-//						vc.updateAllBindings(root.getSelectedClass().getModel(), item, root, deleteOldBindings, confirmationDialog.isAutomaticSelectionOfProviders(), true, false);
-
 						try {
 							// update bindings
 							CreatorValueBinding vc = new CreatorValueBinding();
+							
+							//pass pre-collected mediators in order to avoid new search
+							vc.setAllMediators(getAst().getAllMediators());
+							
 							vc.updateAllBindings(root.getSelectedClass().getModel(), 
 										org.openmodelica.modelicaml.common.instantiation.TreeUtls.classInstantiation, 
@@ -951,9 +883,6 @@
 			}
 		};
-//		actionUpdateBindings.setText("Update bindings in all sub-components");
-//		actionUpdateBindings.setToolTipText("Update bindings in all sub-components");
 		actionUpdateBindings.setText("Update bindings");
 		actionUpdateBindings.setToolTipText("Update bindings in all sub-components");
-//		actionUpdateBindings.setImageDescriptor(ImageDescriptor.createFromFile(Activator.class, "/icons/updateBindings.png"));
 		actionUpdateBindings.setImageDescriptor(ImageDescriptor.createFromImage(ResourceManager.getPluginImage("org.openmodelica.modelicaml.view.valuebindings", "/icons/valueMediator.png")));
 		
Index: /trunk/modelicaml/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/helpers/DeriveValueBindingCodeHelper.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/helpers/DeriveValueBindingCodeHelper.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/helpers/DeriveValueBindingCodeHelper.java	(revision 1632)
@@ -59,4 +59,5 @@
 import org.openmodelica.modelicaml.common.instantiation.TreeObject;
 import org.openmodelica.modelicaml.common.instantiation.TreeParent;
+import org.openmodelica.modelicaml.common.services.StringUtls;
 import org.openmodelica.modelicaml.common.valuebindings.helpers.BindingsDataCollector;
 import org.openmodelica.modelicaml.view.valuebindings.dialogs.SelectValueMediatorDialog;
@@ -198,6 +199,9 @@
 	
 	public String translateClientScript(TreeObject clientTreeObject, String clientOperation, String codeDerivedFromMediator){
+
+		String clientDotPath = clientTreeObject.getDotPath();
+		
 		if (clientTreeObject != null && clientOperation != null) {
-			clientOperation = clientOperation.replaceAll(Constants.MACRO_clientPath, clientTreeObject.getDotPath());
+			clientOperation = clientOperation.replaceAll(Constants.MACRO_clientPath, clientDotPath);
 			if (codeDerivedFromMediator != null) {
 				clientOperation = clientOperation.replaceAll(Constants.MACRO_getBinding+ "\\((\\s+)?\\)", codeDerivedFromMediator);				
@@ -337,10 +341,16 @@
 	
 	public String deriveCodeFromProvider(TreeObject provider, String providerOperation){
+
+		String providerDotPath = provider.getDotPath();
+		
 		if (providerOperation != null ) {
-			providerOperation = providerOperation.replaceAll(Constants.MACRO_providerPath, provider.getDotPath());
+			providerOperation = providerOperation.replaceAll(Constants.MACRO_providerPath, providerDotPath);
+			
 			return providerOperation;
 		}
-		return provider.getDotPath();
-	}
+		return providerDotPath;
+	}
+	
+	
 	
 	private List<TreeObject> getSortedList(HashSet<TreeObject> set){
@@ -996,5 +1006,5 @@
 	}
 	
-	public boolean isRequiredClient() {
+	public boolean isMandatoryClient() {
 		return isRequiredClient;
 	}
